<cfset parentTag=GetBaseTagList()>
<cfif ListFindNoCase(parentTag, "cf_datavalidate") EQ 0>
The parent tag, &lt;cf_datavalidate&gt;, is not specified.
<cfabort>
</cfif>

<cfset parentTag=GetBaseTagData("cf_datavalidate")>
<cfset validTypes="required,numeric,SimpleValue,lenGT,lenLT,Range,email,compare,space,repex,3of4,date,dateCompare,dateRange,dateGT,dateLT,custom">

<cfparam name="attributes.type" default="">
<cfparam name="attributes.value" default="">
<cfparam name="attributes.value1" default="">
<cfparam name="attributes.value2" default="">
<cfparam name="attributes.message" default="">
<cfparam name="attributes.length" default="">
<cfparam name="attributes.start" default="">
<cfparam name="attributes.end" default="">
<cfparam name="attributes.date" default="">
<cfparam name="attributes.startDate" default="">
<cfparam name="attributes.endDate" default="">
<cfparam name="attributes.precision" default="d">
<cfparam name="attributes.formfield" default="">
<cfoutput>

<!--- Validate a valid type is being specified --->
<cfif ListFindNoCase(variables.validTypes,attributes.type) EQ 0>
	You must specify a valid TYPE. <cfif Len(attributes.type)>#UCase(attributes.type)# is not a valid TYPE.<cfelse>No TYPE specified.</cfif>
<cfabort>
</cfif>

<!--- Validate a form field is specified when cf_datavalidate TYPE is a Structure --->
<cfif parentTag.Attributes.Type EQ "Structure" and Len(Trim(Attributes.formfield)) EQ 0>
When &lt;cf_datavalidate output="#parentTag.Attributes.output#" <strong>type="#parentTag.Attributes.Type#"</strong>&gt;, you must specify <strong>FORMFIELD</strong> in the child tag &lt;cf_dataValidateItem&gt;.
<cfabort>
</cfif>
</cfoutput>
<cfscript>
/*

The meat of the custom tag that performs all of the validation

*/
	
switch (attributes.type)
	{
	
	// Validate value has been required
	case "required":
		if (NOT Len(Trim(attributes.value)))
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;

	// Numeric
	case "numeric":
		if (NOT IsNumeric(attributes.value))
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// SimpleValue
	case "SimpleValue":
		if (NOT IsSimpleValue(attributes.value))
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Length Less Than
	case "lenLT":
		if (Len(Trim(attributes.value)) LT attributes.length)
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Length Greater Than
	case "lenGT":
		if (Len(Trim(attributes.value)) GT attributes.length)
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Range
	case "range":
		if (attributes.value LT attributes.start or attributes.value GT attributes.end)
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Validate Email
	case "email":
		if (ListLen(attributes.value, "@") LT 2 OR ListLen(ListGetAt(attributes.value, 2, "@"),".") LT 2)
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Compare two values
	case "compare":
		if (Compare(Trim(attributes.value1), Trim(attributes.value2)))
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Space
	case "space":
		if (REFind('[[:space:]]', Trim(attributes.value)))
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Repetitive Expressions
	case "repex":
		FOR (index=1; index LTE Evaluate(Len(Trim(attributes.value))-3); index=index+1)
			{
			substr=Mid(attributes.value,variables.index,2);
			if (Find(substr, attributes.value, Evaluate(index+2)))
				{
				ArrayAppend(request.setErrors[1],  attributes.message);
				ArrayAppend(request.setErrors[2], attributes.formfield);
				break;
				}
			}	
	break;
	
	// 3of4
	case "3of4":
		if (NOT
			((REFind('[[:upper:]]', attributes.value) AND REFind('[[:digit:]]', attributes.value) AND REFind('[[:punct:]]', attributes.value))
			OR
			(REFind('[[:upper:]]', attributes.value) AND REFind('[[:lower:]]', attributes.value) AND REFind('[[:punct:]]', attributes.value))
			OR
			(REFind('[[:upper:]]', attributes.value) AND REFind('[[:lower:]]', attributes.value) AND REFind('[[:digit:]]', attributes.value))
			OR
			(REFind('[[:lower:]]', attributes.value) AND REFind('[[:digit:]]', attributes.value) AND REFind('[[:punct:]]', attributes.value))))
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// custom validation
	case "custom":
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
	break;

	
	// Date
	case "date":
		if (NOT IsDate(attributes.value))
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Date Greater Than
	case "dateGT":
		if (DateCompare(attributes.value, attributes.date, attributes.precision) EQ 1)
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Date Less Than
	case "dateLT":
		if (DateCompare(attributes.value, attributes.date, attributes.precision) EQ -1)
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;	
	
	// Date Range
	case "dateRange":
		if (DateCompare(attributes.value, attributes.startDate, attributes.precision) EQ -1 OR DateCompare(attributes.value, attributes.endDate, attributes.precision) EQ 1)
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	// Date Compare
	case "dateCompare":
		if (DateCompare(attributes.value1, attributes.value2, attributes.precision) NEQ 0)
		{
		ArrayAppend(request.setErrors[1], attributes.message);
		ArrayAppend(request.setErrors[2], attributes.formfield);
		}
	break;
	
	default:
	break;
	}
</cfscript>

